package org.ow2.odis.core;

import org.objectweb.util.monolog.api.BasicLevel;

public abstract class AbstractMessageListener extends MessageProcessor
        implements Runnable {
    /** The read thread. */
    Thread readThread = null;

    /** if an error occurred stopListening is fixed to true. */
    public boolean stopListening = false;

    /**
     * Instantiates a new message listener.
     * @param server the server
     * @param cnx the Connection
     */
    AbstractMessageListener(AbstractConnectionIn server, IConnection cnx) {
        super(server, cnx);
        readThread = new Thread(this);
    }

    /*
     * (non-Javadoc)
     * @see com.francetelecom.odis.RS232.MessageActor#start()
     */
    public void start() {
        readThread.start();
    }

    /*
     * (non-Javadoc)
     * @see java.lang.Runnable#run()
     */
    public void run() {
        ((AbstractConnectionIn) server).attribute.incNumberConnexion(1);
        try {
            try {
                while (protocol.isStreamStillOpen()) {
                    Thread.sleep(20000);
                }
            } catch (InterruptedException e) {
                LOGGER.log(BasicLevel.INFO,
                        "interrupt exception during read protocol");
            }
            cnx.close();
        } catch (RuntimeException e) {
            LOGGER.log(BasicLevel.ERROR, "Listen exception :", e);
        }
        LOGGER.log(BasicLevel.ERROR, "END LISTENING //" + hashCode());
        stopListening = true;
        ((AbstractConnectionIn) server).attribute.incNumberConnexion(-1);
    }
}
