package org.ow2.odis.core;

import org.ow2.odis.model.AbstractConnectionAttribute;

/**
 * The aim of this interface is to define a protocol this protocol is able to create byte array from a stream
 * @author Beyler Olivier FranceTelecom R&D
 */
public interface IProtocol {
    /**
     * inform that if the stream is still open.
     * @return true or false
     */
    public boolean isStreamStillOpen();

    /**
     * setter.
     * @param attribut allow protocol to get some information about the attribut port.
     */
    public void setConnectionAttribute(AbstractConnectionAttribute attribute);

    /**
     * Sets the properties.
     * @param properties the new properties
     */
    public void setProperties(String properties) throws Exception;

    /**
     * Gets the properties.
     * @return the properties
     */
    public String getProperties();
}
