package org.ow2.odis.core;

import java.util.ArrayList;
import java.util.List;

import org.ow2.odis.sql.MessageListener;

/**
 * The Class ThreadManager.
 * 
 * @author S.Bogaert
 */
public class ThreadManager {

	/** The instance. */
	private static ThreadManager instance = null;
	
	/** The map thread cnx. */
	private List mapThreadCnx = null;
	
	/** The map listener. */
	private List mapListener = null;
	
	/**
	 * Instantiates a new thread manager.
	 */
	private ThreadManager () {
		this.mapThreadCnx = new ArrayList();
		this.mapListener = new ArrayList();
	}
	
	/**
	 * Gets the single instance of ThreadManager.
	 * 
	 * @return single instance of ThreadManager
	 */
	public static ThreadManager getInstance() {
		if (instance == null) {
			instance = new ThreadManager();
		}
		return instance;
	}
	
	/**
	 * Stop all thread.
	 */
	public void stopAllThread() {
		for (int i = 0; i < mapThreadCnx.size(); i++) {
			AbstractKeepConnexion thread = (AbstractKeepConnexion) mapThreadCnx.get(i);
			thread.stop();
		}
		for (int i = 0; i < mapListener.size(); i++) {
			MessageListener thread = (MessageListener) mapListener.get(i);
			thread.stop();
		}
	}

	/**
	 * Adds the.
	 * 
	 * @param abstractKeepConnexion the abstract keep connexion
	 */
	public void add(AbstractKeepConnexion abstractKeepConnexion) {
		this.mapThreadCnx.add(abstractKeepConnexion);
	}

	/**
	 * Adds the.
	 * 
	 * @param messageListener the message listener
	 */
	public void add(MessageListener messageListener) {
		this.mapListener.add(messageListener);
	}
}
