package org.ow2.odis.sql;

import java.sql.SQLException;

import org.objectweb.util.monolog.Monolog;
import org.objectweb.util.monolog.api.BasicLevel;
import org.objectweb.util.monolog.api.Logger;
import org.ow2.odis.connection.context.ContextMessage;
import org.ow2.odis.core.AbstractConnectionOut;
import org.ow2.odis.core.IConnection;
import org.ow2.odis.core.IMessageSender;
import org.ow2.odis.core.MessageProcessor;


public class MessageSender extends MessageProcessor implements IMessageSender {
    /** logger of this class. */
    static final Logger LOGGER = Monolog.initialize().getLogger(
            SqlConnectionOut.class.getName());

    private SqlConnectionAttribute attribut;

    public MessageSender(AbstractConnectionOut server, IConnection cnx) {
        super(server, cnx);
    }

    protected void start() {
        // TODO Auto-generated method stub
    }

    public boolean send(byte[] msg) {
        return false;
    }

    /*
     * (non-Javadoc)
     * @see
     * com.francetelecom.odis.component.connexion.context.IContextualConnexionOut#send(com.francetelecom.odis.component.connexion.context
     * .ContextMessage)
     */
    public boolean send(ContextMessage msg) {
        boolean result = true;
        try {
            result = (((IProtocolOut) protocol).write(msg));
        } catch (SQLException e) {
            if (LOGGER.isLoggable(BasicLevel.ERROR)) {
                LOGGER
                        .log(BasicLevel.ERROR, "SQLException - "
                                + e.getMessage());
            }
        }
        return result;
    }

    /**
     * Getter
     * @return SqlCnxAttribut
     */
    public SqlConnectionAttribute getAttribut() {
        return attribut;
    }

    /**
     * Setter
     * @param attribut the SqlCnxAttribut
     */
    public void setAttribut(SqlConnectionAttribute attribut) {
        this.attribut = attribut;
    }
}
