package org.ow2.odis.sql;

import org.objectweb.util.monolog.Monolog;
import org.objectweb.util.monolog.api.BasicLevel;
import org.objectweb.util.monolog.api.Logger;
import org.ow2.odis.connection.context.Context;
import org.ow2.odis.core.IConnection;
import org.ow2.odis.core.ThreadManager;
import org.ow2.odis.model.AbstractConnectionAttribute;


public class SqlConnection implements IConnection {
    /** The Constant LOGGER. */
    static final Logger LOGGER = Monolog.initialize().getLogger(
            SqlConnection.class.getName());

    public void close() {
        try {
            SqlConnectionHandler.close();
            ThreadManager.getInstance().stopAllThread();
        } catch (Exception e) {
            if (LOGGER.isLoggable(BasicLevel.ERROR)) {
                LOGGER.log(BasicLevel.ERROR, e.getClass() + " "
                        + e.getMessage());
            }
        }
    }

    public Context getContext() {
        return new Context("SQL Connection", "SQL Connection");
    }

    public void open(AbstractConnectionAttribute attribute) {
        SqlConnectionHandler.init((SqlConnectionAttribute) attribute);
    }
}
