package org.ow2.odis.sql;

import org.ow2.odis.model.AbstractAttributeMBean;

/**
 */
public interface SqlConnectionAttributeMBean extends AbstractAttributeMBean {
    /**
     * Gets the Database.
     * @return the url
     */
    String getDatabase();

    /**
     * Gets the Url.
     * @return the url
     */
    String getUrl();

    /**
     * Gets the login.
     * @return the login
     */
    String getLogin();

    /**
     * Gets the password.
     * @return the password
     */
    String getPassword();

    /**
     * Gets the driver.
     * @return the driver
     */
    String getDriver();

    /**
     * Gets the select query.
     * @return the select query
     */
    String getSelectQueryName();

    /**
     * Gets the action queries.
     * @return the action queries
     */
    String getActionQueriesAsString();

    /**
     * Adds the or modify action query.
     * @param name the name
     * @return true, if successful
     */
    boolean addOrModifyActionQuery(String name, String query);

    /**
     * Removes the action query.
     * @param name the name
     * @return true, if successful
     */
    boolean removeActionQuery(String name);

    /**
     * Gets the server side.
     * @return the server side
     */
    String getServerSide();

    /**
     * Gets the state string.
     * @return the state string
     */
    String getStateString();

    /**
     * Gets the connection pool size.
     * @return the pool size
     */
    String getPoolSize();
}
