package org.ow2.odis.sql;

import org.objectweb.util.monolog.Monolog;
import org.objectweb.util.monolog.api.BasicLevel;
import org.objectweb.util.monolog.api.Logger;
import org.ow2.odis.core.AbstractConnectionIn;
import org.ow2.odis.core.AbstractKeepConnexion;

public class SqlConnectionIn extends AbstractConnectionIn {
    /** logger of this class. */
    static final Logger LOGGER = Monolog.initialize().getLogger(
            SqlConnectionIn.class.getName());

    /**
     * Constructor.
     * @param attribut the attribute
     */
    public SqlConnectionIn(SqlConnectionAttribute attribute) {
        super(attribute);
        attribute.addObserver(this);
        if (LOGGER.isLoggable(BasicLevel.DEBUG)) {
            LOGGER.log(BasicLevel.DEBUG, "Create SqlConnectionIn");
        }
    }

    /*
     * (non-Javadoc)
     */
    protected AbstractKeepConnexion getKeepConnection() {
        return new SqlKeepConnectionListener(this, (SqlConnectionAttribute) attribute);
    }
}
