package org.ow2.odis.sql;

import java.sql.PreparedStatement;
import java.sql.SQLException;

import org.objectweb.util.monolog.Monolog;
import org.objectweb.util.monolog.api.BasicLevel;
import org.objectweb.util.monolog.api.Logger;
import org.ow2.odis.exception.OdisAttributeException;


public class StatementParameterBean {
    /** logger of this class. */
    static final Logger LOGGER = Monolog.initialize().getLogger(
            StatementParameterBean.class.getName());

    private Object value;

    private byte[] payload;

    private String type;

    public Object getValue() {
        return value;
    }

    public void setValue(Object value) {
        this.value = value;
    }

    public void setPayload(byte[] payload) {
        this.payload = payload;
    }

    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
    }

    public void setInStatement(PreparedStatement pstmt, int parameterIndex)
            throws SQLException, OdisAttributeException {
        if (LOGGER.isLoggable(BasicLevel.DEBUG)) {
            LOGGER.log(BasicLevel.DEBUG, "setInStatement: parameterIndex="
                    + parameterIndex + " - value=" + value + " - payload="
                    + payload + " - type=" + type);
        }
        if (this.payload != null) {
            ResultSetHelper.setInStatement(pstmt, parameterIndex, type, payload);
        } else {
            ResultSetHelper.setInStatement(pstmt, parameterIndex, type, value);
        }
    }
}
